function X=triu_Vec(A,B)
% A : N-by-d-by-d 
% b : N-by-d-by-m or N-by-d or d-by-m      or d-by-1
% x : N-by-d-by-m or N-by-d or N-by-d-by-m or N-by-d
  assert(fc_linalg3D.is3Darray(A));
  [dimA,dimB]=fc_linalg3D.getDimensions(A,B);
  assert( dimA(2)==dimA(3) && dimA(3)==dimB(2) );
  N=dimA(1);d=dimA(2);m=dimB(3);
  getB=fc_linalg3D.getVec(B,N);
  
  X=zeros(N,d,m);
  S=zeros(N,1);
  for l=1:m 
    for i=d:-1:1
      S=0*S;
      for j=i+1:d
        S=S+A(:,i,j).*X(:,j,l);
      end
      X(:,i,l)=(getB(B,i,l)-S)./A(:,i,i);
    end
  end
  
end
